Var         pis, xs, rs, pi, x, r, q, ys, as, vx, pih, vsx, a, vpi, s, y,
            obs_rs, obs_pi, obs_xs, obs_q, obs_r, obs_pis, obs_x;
Varexo      esr, esa, esx, er, ea, epi, ex;
Parameters  BETA, K, SIGMA, TAU, IOTA, RHOx, RHOa, ALPHA,  
            THETA, RHOr, ALPHApi, ALPHAx, RHOpi, PHIt, PHI, RHOsa,
            RHOsx, RHOsr, ALPHAspi, ALPHAsx, SIGMAr, SIGMAaa, SIGMAx, SIGMAsr, SIGMAsa, SIGMAsx;
K = 0.2;
BETA = 0.99;
ALPHA = 0.3;
SIGMA = 1;
TAU = 1;
IOTA = 1;
PHI = 3;
PHIt= 2;
 
 
THETA = 0.5;
 
RHOx = 0.85;
RHOa = 0.8;
 

RHOr = 0.8;
ALPHAx = 0.05;
ALPHApi= 0.4;
 
RHOsr = 0.8;
ALPHAsx = 0.05;
ALPHAspi= 0.4;
 
RHOpi = 0.8;
RHOsa = 0.7;
RHOsx = 0.7;
 
SIGMAaa = 0; 
SIGMAx = 0;
SIGMAr = 0.003; 
SIGMApi = 0;
SIGMAsa = 0; 
SIGMAsx = 0;
SIGMAsr = 0;
 
 
 
model;
 
#OMEGA= SIGMA*TAU+(1-ALPHA)*(SIGMA*IOTA-1); 
#SIGMAa = SIGMA/((1-ALPHA)+ALPHA*OMEGA);
#PHIa = (1+PHI)/(SIGMA + PHI);
#PHIb = (SIGMAa-SIGMA)/(SIGMAa+PHI);
#PHIc = ALPHA*(OMEGA-1)+PHIb;
#PHId = (1+PHI)/(SIGMAa+PHI);
#LAMDA = (1-THETA)*(1-THETA*BETA)/THETA;
#Ka = LAMDA*(SIGMAa+PHI);
 
// phlip nuoc lon
pis = BETA*pis(+1)+xs*K;
 
// IS nuoc lon
xs = xs(+1)-(1/SIGMA)*(rs-pis(+1))-PHIa*(1-RHOsa)*as+((1-RHOsx)/SIGMA)*vsx;
 
// taylor nuoc lon
rs = RHOsr*rs(-1)+ALPHAspi*pis+ALPHAsx*xs+esr;
 
// output tiem nang 
xs = ys-PHIa*as;
 
// IS
x= x(+1)-(1/SIGMAa)*(r-pih(+1))+PHIc*(ys(+1)-ys)+((1-RHOx)*(1-PHIb)/SIGMA)*vx+((1-RHOsx)/SIGMA)*PHIc*vsx-PHId*(1-RHOa)*a;
 
// phlip
pih = BETA*pih(+1)+Ka*x+vpi;
 
// taylor
r = RHOr*r(-1)+ALPHApi*pi+ALPHAx*x+er;
 
// lien he giua lam phat hang hoa va lam phat trong nuoc
pi = pih +ALPHA*(s-s(-1));
 
q = q(-1)+(1-ALPHA)*(s-s(-1));
 
s = SIGMAa*(y-ys)-(SIGMAa/SIGMA)*(vx-vsx);
 
x = y - PHIt*ys-(PHIb/SIGMA)*(vx-vsx)-PHId*a;
 
//shock 
a = RHOa*a(-1)+ea;
vpi = RHOpi*vpi(-1)+epi;
vx = RHOx*vx(-1)+ex;
as= RHOsa*as(-1)+esa;
vsx = RHOsx*vsx(-1)+esx;
 
 
//observed variables
obs_rs   = rs;
obs_pi  = pi;
obs_xs   = x; 
obs_q   = q;
obs_r   = r;
obs_pis  = pis;
obs_x   = x; 
   
    
end;
 
initval;
pis = 0;
xs = 0;
rs = 0;
pi = 0;
x = 0;
r = 0;
q = 0;
ys = 0;
pih = 0;
s = 0;
y = 0;

end;
 
steady;
 
check;
 
shocks; 
var er;stderr 100*SIGMAr;
var ea = SIGMAaa^2;
var ex = SIGMAx^2;
var epi= SIGMApi^2;
var esr = SIGMAsr^2;
var esa = SIGMAsa^2;
var esx = SIGMAsx^2;
end;
 
stoch_simul(dr_algo = 0, order = 1, periods = 5000, irf=40); 

varobs xs pis rs x pi r q;

estimated_params;

THETA,      beta_pdf,0.50,0.10;
RHOr,       beta_pdf,0.80,0.02;
ALPHAx,     normal_pdf,0.05,0.10;
ALPHApi,    normal_pdf,0.40,0.10;
RHOsr,      beta_pdf,0.80,0.10;
ALPHAsx,    normal_pdf,0.05,0.10;
ALPHAspi,   normal_pdf,0.40,0.10;
RHOpi,      beta_pdf,0.80,0.02;
RHOsa,      beta_pdf,0.70,0.05;
RHOsx,      beta_pdf,0.70,0.10;
stderr ea,  inv_gamma_pdf, 0.01, inf;
stderr ex,  inv_gamma_pdf, 0.01, inf;
stderr epi, inv_gamma_pdf, 0.01, inf;
stderr er,  inv_gamma_pdf, 0.01, inf;
stderr esa, inv_gamma_pdf, 0.01, inf;
stderr esx, inv_gamma_pdf, 0.01, inf;
stderr esr, inv_gamma_pdf, 0.01, inf;

end;
  
estimation(datafile = data1, xls_range=U1:AA105, mode_check, bayesian_irf);
 
 

